# This override can used for development, mapping the directories in the Docker containers
# to the local directories. Rename to docker-compose.override.yml to use transparently.
# docker-compose.override.yml has been added to .gitignore to avoid incidental deployment 
# to the servers.
#
# Usage: set LOCAL_x full paths in your local .env file, e.g. 
# API_REPO_PATH=/Users/ruud/PhpStorm/expeditie-online/api-expeditie-online
#
# API_REPO_PATH=
# ADMIN_REPO_PATH=
# HARVESTER_REPO_PATH=
# PIPELINE_REPO_PATH=
# DOCUMENT_LOADER_REPO_PATH=

services:

  # Fix Route53 DNS errors on the Mac
  traefik:
    image: registry.gitlab.com/naturalis/lib/docker/traefik:latest
    #image: traefik:${TRAEFIK_VERSION:?err}
    restart: ${CONTAINER_RESTART:-unless-stopped}
    depends_on:
      - docker-socket-proxy
      - api
      - minio
      - admin
    networks:
      - docker-socket-proxy
      - web
    ports:
      - "${HOST_IP:-0.0.0.0}:80:80"
      - "${HOST_IP:-0.0.0.0}:443:443"
      - "127.0.0.1:${TRAEFIK_API_PORT:-8079}:8080"
    volumes:
      - "${BASE_PATH:-/data}/letsencrypt:/letsencrypt"
    command:
      - "--global.sendAnonymousUsage=false"
      - "--log.level=${TRAEFIK_LOG_LEVEL:-ERROR}"
      - "--api=${TRAEFIK_API_ENABLED:-false}"
      - "--api.insecure=true"
      - "--entrypoints.web.address=:80"
      - "--entrypoints.web.http.redirections.entrypoint.to=websecure"
      - "--entrypoints.web.http.redirections.entrypoint.scheme=https"
      - "--entrypoints.web.http.redirections.entrypoint.permanent=true"
      - "--entrypoints.websecure.address=:443"
      - "--certificatesresolvers.route53.acme.dnschallenge=true"
      - "--certificatesresolvers.route53.acme.dnschallenge.provider=route53"
      - "--certificatesresolvers.route53.acme.dnschallenge.resolvers=1.1.1.1:53,8.8.8.8:53"
      - "--certificatesresolvers.route53.acme.storage=/letsencrypt/route53.json"
      - "--providers.docker=true"
      - "--providers.docker.exposedbydefault=false"
      - "--providers.docker.endpoint=tcp://docker-socket-proxy:2375"
      - "--providers.docker.network=docker-socket-proxy"
    env_file:
      - .env

  api:
    volumes:
      - "${API_REPO_PATH:-/tmp}:/app:rw,delegated"

  admin:
    volumes:
      - "${ADMIN_REPO_PATH:-/tmp}/code:/var/www/html:rw,delegated"

  harvester:
    volumes:
      - "${HARVESTER_REPO_PATH:-/tmp}:/app:rw,delegated"

  generator:
    volumes:
      - "${PIPELINE_REPO_PATH:-/tmp}:/app:rw,delegated"

  publisher:
    volumes:
      - "${PIPELINE_REPO_PATH:-/tmp}:/app:rw,delegated"

  document_loader:
    volumes:
      - "${DOCUMENT_LOADER_REPO_PATH:-/tmp}:/app:rw,delegated"
